package logo;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

/**
 * Titre :        Logo
 * Description :  Un exemple de programme graphique utilisant la clbre Tortue Logo
 * Copyright :    Copyright (c) 2000
 * Socit :      LIRMM
 * @author J. Ferber
 * @version 2.0
 */

public class FeuilleDessin extends JPanel {

        ArrayList<Tortue> tortues=new ArrayList<Tortue>(); // la liste des tortues enregistrees

        boolean showTurtles=true;
        
        Image drawingImage;

        public void addTortue(Tortue o){
		tortues.add(o);
        }

        void reset(){
		Dimension dim=getSize();
		drawingImage = this.createImage(dim.width,dim.height);
		Graphics g = drawingImage.getGraphics();
		Color c = g.getColor();
		g.setColor(Color.white);
		g.fillRect(0,0,dim.width, dim.height);
		g.setColor(c);
	}

	public void paintComponent(Graphics g){
	    if (drawingImage==null)
                reset();
            g.drawImage(drawingImage,0,0,null);
            if (showTurtles)
		showTurtles(g);
	}

	public void drawIt(){
            Graphics g = getGraphics();
            g.drawImage(drawingImage,0,0,null);
            if (showTurtles)
		showTurtles(g);
	}

	public Graphics getImageGraphics(){
            if (drawingImage == null)
		reset();
            return drawingImage.getGraphics();
	}

	void showTurtles(Graphics g){
            for(Iterator it = tortues.iterator();it.hasNext();){
		Tortue t = (Tortue) it.next();
		t.drawTurtle(g);
            }
	}
}
